Not So Random - Round-E APAC Test of Google 2016 (Problem C)


http://www.dss886.com/algorithm/2016/05/18/21-36
There is a certain “random number generator” (RNG) which takes one nonnegative integer as input and generates another nonnegative integer as output. But you know that the RNG is really not very random at all! It uses a fixed number K, and always performs one of the following three operations:
  • with probability A/100: return the bitwise AND of the input and K
  • with probability B/100: return the bitwise OR of the input and K
  • with probability C/100: return the bitwise XOR of the input and K (You may assume that the RNG is truly random in the way that it chooses the operation each time, based on the values of A, B, and C.)
You have N copies of this RNG, and you have arranged them in series such that output from one machine will be the input for the next machine in the series. If > you provide X as an input to the first machine, what will be the expected value of the output of the final machine in the series?
Input
The first line of the input gives the number of test cases, T. T test cases follow; each consists of one line with six integers N, X, K, A, B, and C. Respectively, these denote the number of machines, the initial input, the fixed number with which all the bitwise operations will be performed (on every machine), and 100 times the probabilities of the bitwise AND, OR, and XOR operations.
Output
For each test case, output one line containing “Case #x: y”, where x is the test case number (starting from 1) and y is the expected value of the final output. y will be considered correct if it is within an absolute or relative error of 10^-9 of the correct answer. See the FAQ for an explanation of what that means, and what formats of real numbers we accept.
Limits
1 ≤ T ≤ 50.
0 ≤ A ≤ 100.
0 ≤ B ≤ 100.
0 ≤ C ≤ 100.
A+B+C = 100.
Small dataset
1 ≤ N ≤ 10.
0 ≤ X ≤ 10^4.
0 ≤ K ≤ 10^4.
Large dataset
1 ≤ N ≤ 10^5.
0 ≤ X ≤ 10^9.
0 ≤ K ≤ 10^9.
Sample
InputOutput
3 
1 5 5 10 50 40Case #1: 3.0000000000
2 5 5 10 50 40Case #2: 3.6000000000
10 15 21 70 20 10Case #3: 15.6850579098
In sample test case #1, the final output will be 5 if AND or OR happens and 0 if XOR happens. So the probability of getting 5 is (0.1 + 0.5) and the probability of getting 0 is 0.4. So the expected final output is 5 * 0.6 + 0 * 0.4 = 3.
In sample test case #2, the final output will be 5 with probability 0.72, and 0 otherwise.

首先理一下题意,把N个RNG串起来,求最后输出结果的期望值。这里很容易注意到,RNG内部的操作(与、或、异或)都是位运算,而一个二进制整数的期望可以用每一位比特的期望乘以所在位的权重计算得到,那么本题就可以简化为只考虑单个比特在系统内的流程来得到单个比特位的期望值。

单个RNG

只考虑一个bit的话,X和K的值组合只有4种,可以列出下面的操作结果表:
ABC
 0 & 0 = 0  0 | 0 = 0  0 ^ 0 = 0 
 0 & 1 = 0  0 | 0 = 1  0 ^ 1 = 1 
 1 & 0 = 0  0 | 0 = 1  1 ^ 0 = 1 
 1 & 1 = 1  1 | 1 = 1  1 ^ 1 = 0 
注意到这里虽然有A、B、C三种可能性,但是输入和输出都是0和1,是不是可以尝试一下用转移矩阵来做呢?
因为输入是X、输出是0或1,而K是相对固定的、每个RNG的K值都相同。因此,对照上面的结果表分别计算K=0和K=1时的转移矩阵:
k = 0:
[ 100 ,  0 ]
[ A , B+C ]
k = 1:
[ A , B + C ]
[ C , A + B ]
(即k=1,输入为0时,输出A%为0、(B+C)%为1;输入为1时,输出C%为0,(A+B)%为1)
这样,我们就将RNG内部当作了一个黑箱,将内部的三种操作简化成了输入输出的转移矩阵。

多个RNG串联

有了单个RNG的转移矩阵,K值又不变,就可以分别计算K=0和K=1时多个RNG的串联结果了,将N-1个矩阵相乘即可。

https://github.com/dss886/LeetCode/blob/master/src/company/google/NotSoRandom.java
* From the Round-E APAC Test of Google 2016 (Problem C)
* https://code.google.com/codejam/contest/8264486/dashboard#s=p2
*
* The main solving ideas:
* 1. All Three operation is bit-based, so we can look into the operation of single bit.
* 2. Instead of considering the 3 operations and their probabilities, we can just think about the input and output
*    probability of 0-1, then we got two matrices as below:
*        k = 0: [ 100 ,  0   ] , k = 1: [  A  , B + C ]
*               [  A  , B+C  ]          [  C  , A + B ]
*    (which means: when x=0 and k=1, the output got 0 by chance of A%, and 1 by chance of (B+C)%)
* 3. When have N copies of this RNG in series, we multiply the matrices to itself by N-1 times, then we got the total
*    system's output matrices.
* 4. Now for every bit of X and K, we can calculate the output bit chance from the matrices above, then we can finally
*    got the result.
*
* For example:
*    N=1, X=5, K=5, A=10, B=50, C=40, the single and total matrices (N=1) is:
*        k = 0: [ 100 ,  0  ] , k = 1: [  10  , 90 ]
*               [ 10  , 90  ]          [  40  , 60 ]
*    X = 00000000000000000000000000000101
*    K = 00000000000000000000000000000101
*    1. when bit of X and K are both 0, the output bit is 0 by 100%.
*    2. when bit of X and K are both 1, the output bit is 0 by 40% and 1 by 60%.
*    So the expect value of result is (60% * 4 + 60% * 1), which is 3.
*
* For Improvement:
*   The main time-consuming part of this solution is the multiplication of matrices.
*   Some fast matrix multiplication like the Strassen-Algorithm will reduce the consumed time.
*/
public class NotSoRandom {
   public static void main(String[] args) {
       Scanner scanner = new Scanner(System.in);
       while (scanner.hasNext()) {
           int T = scanner.nextInt();
           for (int t = 0; t < T; t++) {
               int N = scanner.nextInt();
               int X = scanner.nextInt();
               int K = scanner.nextInt();
               int A = scanner.nextInt();
               int B = scanner.nextInt();
               int C = scanner.nextInt();
               Matrix bitZero = new Matrix(100, 0, A, B + C);
               Matrix bitOne = new Matrix(A, B + C, C, A + B);
               Matrix bitZeroAfterK = bitZero;
               Matrix bitOneAfterK = bitOne;
               for (int n = 1; n < N; n++) {   // Maybe some Fast-Matrix-Multiplication will do it faster.
                   bitZeroAfterK = multiply(bitZeroAfterK, bitZero);
                   bitOneAfterK = multiply(bitOneAfterK, bitOne);
               }
               double result = 0;
               for (int i = 31; i >= 0; i--) {
                   result *= 2;
                   Matrix matrix = isLastZero(K, i) ? bitZeroAfterK : bitOneAfterK;
                   double chanceOfOne = (isLastZero(X, i) ? matrix.b : matrix.d) / 100;
                   result += chanceOfOne;
               }
               print(t, result);
           }
       }
   }

   private static boolean isLastZero(int num, int position) {
       return (num >>> position) % 2 == 0;
   }

   private static void print(int t, double result) {
       System.out.println("Case #" + (t + 1) + ": " + result);
   }

   private static Matrix multiply(Matrix m1, Matrix m2) {
       double a = (m1.a * m2.a + m1.b * m2.c) / 100;
       double b = (m1.a * m2.b + m1.b * m2.d) / 100;
       double c = (m1.c * m2.a + m1.d * m2.c) / 100;
       double d = (m1.c * m2.b + m1.d * m2.d) / 100;
       return new Matrix(a, b, c, d);
   }

   private static class Matrix {
       private double a, b, c, d;
       public Matrix(double a, double b, double c, double d) {
           this.a = a;
           this.b = b;
           this.c = c;
           this.d = d;
       }
   }

http://goudan-er.xyz/2016/Google-APAC-2016-RoundE-Problem-C/
对于数字二进制下的每一位只有两种状态0或者1,同时每一位相互独立,所以可以分开考虑每一位,就算出经过N步之后每一位为1的概率,则最后的期望可以表示为:expect=j=031pj(1«j) ,pj表示经过N步随机数字生成函数后第j位为1的概率。
所以,有DP:
令dp[i][j][s]表示经过i步随机数字生成函数后第j位状态为s的概率,s = 0 / 1,有状态转移方程:
If (k & (1 << j)) > 0 :
dp[i][j][0] += dp[i-1][j][0] * a / 100
dp[i][j][0] += dp[i-1][j][1] * c / 100
dp[i][j][1] += dp[i-1][j][1] * a / 100
dp[i][j][1] += dp[i-1][j][0] * b / 100
dp[i][j][1] += dp[i-1][j][1] * b / 100
dp[i][j][1] += dp[i-1][j][0] * c / 100
Else :
dp[i][j][0] += dp[i-1][j][0] * a / 100
dp[i][j][0] += dp[i-1][j][1] * a / 100
dp[i][j][0] += dp[i-1][j][0] * b / 100
dp[i][j][0] += dp[i-1][j][0] * c / 100
dp[i][j][1] += dp[i-1][j][1] * b / 100
dp[i][j][1] += dp[i-1][j][1] * c / 100
初始化,则根据X的每一位0或者1,对dp[0][j][0]和dp[0][j][1]赋值1或者0。
typedef long long lld;
 
const int N = 111111;
const int M = 31; // x & k >= 0, bit(31) = 0
 
double dp[N][M][2];
 
double solve()
{
    double ret = 0.0;
    int n, x, k, a, b, c;
    cin >> n >> x >> k >> a >> b >> c;
 
    // init
    clr(dp, 0);
    for (int j = 0; j < M; ++j) {
        if ( x & (1 << j) ) {
            dp[0][j][0] = 0.0;
            dp[0][j][1] = 1.0;
        } else {
            dp[0][j][0] = 1.0;
            dp[0][j][1] = 0.0;
        }
    }
 
    // dp
    for (int j = 0; j < M; ++j) {
        for (int i = 1; i <= n; ++i) {
            if ( k & (1 << j) ) {
                dp[i][j][0] += dp[i-1][j][0] * a / 100;
                dp[i][j][0] += dp[i-1][j][1] * c / 100;
                dp[i][j][1] += dp[i-1][j][1] * a / 100;
                dp[i][j][1] += (dp[i-1][j][0] + dp[i-1][j][1]) * b / 100;
                dp[i][j][1] += dp[i-1][j][0] * c / 100;
            } else {
                dp[i][j][0] += (dp[i-1][j][0] + dp[i-1][j][1]) * a / 100;
                dp[i][j][0] += dp[i-1][j][0] * b / 100;
                dp[i][j][0] += dp[i-1][j][0] * c / 100;
                dp[i][j][1] += dp[i-1][j][1] * b / 100;
                dp[i][j][1] += dp[i-1][j][1] * c / 100;
            }
        }
        ret += dp[n][j][1] * (1 << j);
    }
 
    return ret;
}
 
int main ()
{
    freopen("F:/#test-data/in.txt", "r", stdin);
    freopen("F:/#test-data/out.txt", "w", stdout);
    ios::sync_with_stdio(false); cin.tie(0);
    cout << fixed << showpoint;
    int t; cin >> t;
    for (int cas = 1; cas <= t; ++cas) {
        cout << "Case #" << cas << ": ";
        cout << setprecision(9) << solve() << endl;
    }
    return 0;
}
http://blog.csdn.net/ww32zz/article/details/51362183
题目大意:对于一个“随机数生成器”,给定,输出的结果可能有三种,①  ② ③。求重复操作次,最后得到的结果的期望值。
思路:首先理解求的是什么——期望,即:。所以要求解问题,就要知道有哪些可能的取值,并计算其概率。但是可能的取值太多,计算概率也很麻烦,所以要寻找突破口——位运算。因为提供的运算都是位运算:按位与、按位或、按位异或,并且每一个bit都是相互独立的。因此第一反应应该是将问题分解为逐位求期望。则问题转化为:。所以我们只需要求每一个bit贡献的期望,然后累加到结果中就行了。
有了以上思路,接下来就是怎么求解某个bit的期望了。不失一般性,以下对第位进行分析。在整个运算中,是不变的,来一个输入变量,可以很快求出结果为0、为1的概率。如下:
有了上述一轮运算的状态迁移后,我们可以写出状态的递推关系:
 
由此可得状态转移矩阵:
对给定的输入,初始概率可以根据bit为0或者为1求得,进行轮则对状态转移矩阵求次幂即可,使用快速幂复杂度为


总结:首先要理解题意,将要解决的原始问题想清楚,再从算法的角度去考虑问题。对于有限的状态转换,可以使用状态转移矩阵来表示,然后将重复的操作转换成矩阵连乘,还可以使用快速幂进行优化。

  1. void multiply(double m1[], double m2[]){  
  2.     double ans[] = {0, 0, 0, 0};  
  3.     ans[0] = m1[0] * m2[0] + m1[1] * m2[2];  
  4.     ans[1] = m1[0] * m2[1] + m1[1] * m2[3];  
  5.     ans[2] = m1[2] * m2[0] + m1[3] * m2[2];  
  6.     ans[3] = m1[2] * m2[1] + m1[3] * m2[3];  
  7.     for(int i = 0; i < 4; ++i)  
  8.         m1[i] = ans[i];  
  9. }  
  10.   
  11. int main(){  
  12.     int tc, ca = 0;  
  13.     cin >> tc;  
  14.     while(tc--){  
  15.         int n, x, k;  
  16.         double a, b, c;  
  17.         cin >> n >> x >> k >> a >> b >> c;  
  18.         a /= 100, b /= 100, c /= 100;  
  19.         /*ans0,ans1保存最终的状态*/  
  20.         double ans0[] = {1, 0, 0, 1}, ans1[] = {1, 0, 0, 1};  
  21.         double cur0[] = {1, a, 0, b + c}, cur1[] = {a, c, b + c, a + b};  
  22.         while(n){  
  23.             if(n & 1)  
  24.                 multiply(ans0, cur0), multiply(ans1, cur1);  
  25.             multiply(cur0, cur0), multiply(cur1, cur1);  
  26.             n >>= 1;  
  27.         }  
  28.         /*按位求期望*/  
  29.         int base = 1;  
  30.         double res = 0;  
  31.         while(x || k){  
  32.             /*p0,p1表示初始状态为0,1的概率,c0,c1表示相应的矩阵系数*/  
  33.             double p1 = x & 1 ? 1 : 0, p0 = 1 - p1;  
  34.             double c0, c1;  
  35.             if(k & 1)  
  36.                 c0 = ans1[2], c1 = ans1[3];  
  37.             else  
  38.                 c0 = ans0[2], c1 = ans0[3];  
  39.             res += (c0 * p0 + c1 * p1) * base;  //求解当前bit的期望  
  40.             base <<= 1, x >>= 1, k >>= 1;  
  41.         }  
  42.         printf("Case #%d: %.10lf\n", ++ca, res);  
  43.     }  
  44. }  

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts